<!-- Harbor -->
<div class="app-modal">
  <div class="app-modal-header bg-dark d-flex flex-row justify-content-between">Harbor</div>
  <div class="app-modal-body">

    <!-- Info display -->
    <div class="harbor-info">

      <!-- Settings to configure the Harbor instance to use -->
      <h2>Harbor instance</h2>
      <div class="row my-1">
        <strong class="col col-md-3">
          Harbor module
          <i class="fa-solid fa-circle-info ms-2 text-primary" data-bs-toggle="tooltip" data-bs-placement="right" data-bs-title="Terraform module used to create Harbor resources (project, robot account, etc) for each app"></i>
        </strong>
        <pre class="col col-md-9 mb-0">{% if harbor_config.harbor_module %}{{ harbor_config.harbor_module }}{% else %}Not set{% endif %}</pre>
      </div>
      <div class="row my-1">
        <strong class="col col-md-3">
          Harbor URL
          <i class="fa-solid fa-circle-info ms-2 text-primary" data-bs-toggle="tooltip" data-bs-placement="right" data-bs-title="URL of your Harbor server. Make sure Strapper can reach this server"></i>
        </strong>
        <pre class="col col-md-9 mb-0">{% if harbor_config.harbor_url %}{{ harbor_config.harbor_url }}{% else %}Not set{% endif %}</pre>
      </div>
      <div class="row my-1">
        <strong class="col col-md-3">
          Harbor username
          <i class="fa-solid fa-circle-info ms-2 text-primary" data-bs-toggle="tooltip" data-bs-placement="right" data-bs-title="Username of an admin account that creates necessary resources for each app on behalf of Strapper. This admin account can be created within Harbor"></i>
        </strong>
        <pre class="col col-md-9 mb-0">{% if harbor_config.harbor_username %}{{ harbor_config.harbor_username }}{% else %}Not set{% endif %}</pre>
      </div>
      <div class="row my-1">
        <strong class="col col-md-3">
          Harbor password
          <i class="fa-solid fa-circle-info ms-2 text-primary" data-bs-toggle="tooltip" data-bs-placement="right" data-bs-title="Password of an admin account that creates necessary resources for each app on behalf of Strapper. This admin account can be created within Harbor"></i>
        </strong>
        {% if harbor_config.harbor_password %}
          <span class="password-display col col-md-9">
          <pre class="password mb-0">****************</pre>
          <pre class="text d-none mb-0"><code>{{ harbor_config.harbor_password }}</code></pre>
            <div class="show-btn">Show</div>
          </span>
        {% else %}
        <pre class="col col-md-9 mb-0">Not set</pre>
        {% endif %}
      </div>
      <div class="row my-1">
        <strong class="col col-md-3">
          Harbor robot name prefix
          <i class="fa-solid fa-circle-info ms-2 text-primary" data-bs-toggle="tooltip" data-bs-placement="right" data-bs-title="Prefix for robot account names. Default to '$robot'. Make sure to configure this within Harbor first, then update the prefix here"></i>
        </strong>
        <pre class="col col-md-9 mb-0">{{ harbor_config.harbor_robot_account_name_prefix }}</pre>
      </div>

      <!-- Settings to configure container scanning -->
      <h2 class="mt-4">Container scanning</h2>

      <div class="mt-2">
        <a href="{% url 'apps_scan_reports' %}" target="_blank" class="btn btn-primary btn-sm">View last scan report for all apps</a>
      </div>

      <div class="mt-3 mb-4">
        <div class="row">
          <strong class="col col-md-5">Vulnerability severity level threshold</strong>
                          <pre class="col col-md-7 mb-0">{% if harbor_config.severity_threshold %}{{ harbor_config.severity_threshold }}{% else %}High{% endif %}</pre>
        </div>
        <div class="form-text">Containers with a vulnerability that's at this level or higher CANNOT be deployed</div>
      </div>

      <div class="my-4">
        <div class="row">
          <strong class="col col-md-5">Set "Unknown" criticality</strong>
                          <pre class="col col-md-7 mb-0">{% if harbor_config.unknown_criticality %}{{ harbor_config.unknown_criticality }}{% else %}High{% endif %}</pre>
        </div>
        <div class="form-text">"Unknown" vulnerabilities will be seen as severe as the level set here</div>
      </div>

      <div class="my-4">
        <div class="row">
          <strong class="col col-md-5">Rescan interval</strong>
          <pre class="col col-md-7 mb-0">{% if harbor_config.rescan_interval %}{{ harbor_config.rescan_interval }}{% else %}Not set{% endif %}</pre>
        </div>
        <div class="form-text">Set a period to trigger a scan job for all containers</div>
      </div>

      <div class="my-4">
        <div class="row">
          <div class="col col-md-5">
            <div>
              <strong>Vulnerabilities notification email template</strong>
              <button class="btn btn-sm btn-outline-dark ms-3 {% if disable_email %}disabled{% endif %}" data-bs-toggle="modal" data-bs-target="#testEmailModal">Test email</button>
              {% include 'admin_users/modals/test_email.html' %}
            </div>
            <div class="form-text">Email template used to notify app developers when severe vulnerabilities are detected in one of their containers.</div>
          </div>
          {% if disable_email %}
            <div class="col col-md-7 mb-0">
              <div class="alert alert-warning" role="alert">
                Email notification is disabled. Please set <strong>EMAIL_HOST_USER</strong> in your <strong>settings.py</strong> file to enable email notification.
              </div>
            </div>
          {% else %}
                          <pre class="col col-md-7 mb-0">{% if harbor_config.vuln_notification_email_template %}{{ harbor_config.vuln_notification_email_template }}{% else %}Not set{% endif %}</pre>
          {% endif %}
        </div>
      </div>

      <button type="button" class="btn btn-outline-dark btn-sm mt-3 edit-btn">Edit</button>
    </div>

    <!-- Form -->
    <form
      action="{% url 'update_harbor_config' %}"
      method="post"
      class="harbor-form d-none">
      {% csrf_token %}
      <!-- Settings to configure the Harbor instance to use -->
      <h2>Harbor instance</h2>
      <div class="row my-1">
        <strong class="col col-md-3">
          Harbor module
          <i class="fa-solid fa-circle-info ms-2 text-primary" data-bs-toggle="tooltip" data-bs-placement="right" data-bs-title="Terraform module used to create Harbor resources (project, robot account, etc) for each app"></i>
        </strong>
        <span class="col col-md-9">
          <input type="text" name="harbor_module" class="form-control col col-md-9" {% if harbor_config.harbor_module %}value="{{ harbor_config.harbor_module }}"{% endif %}>
        </span>
      </div>
      <div class="row my-1">
        <strong class="col col-md-3">
          Harbor URL
          <i class="fa-solid fa-circle-info ms-2 text-primary" data-bs-toggle="tooltip" data-bs-placement="right" data-bs-title="URL of your Harbor server. Make sure Strapper can reach this server"></i>
        </strong>
        <span class="col col-md-9">
          <input type="text" name="harbor_url" class="form-control col col-md-9" {% if harbor_config.harbor_url %}value="{{ harbor_config.harbor_url }}"{% endif %}>
        </span>
      </div>
      <div class="row my-1">
        <strong class="col col-md-3">
          Harbor username
          <i class="fa-solid fa-circle-info ms-2 text-primary" data-bs-toggle="tooltip" data-bs-placement="right" data-bs-title="Username of an admin account that creates necessary resources for each app on behalf of Strapper. This admin account can be created within Harbor"></i>
        </strong>
        <span class="col col-md-9">
          <input type="text" name="harbor_username" class="form-control col col-md-9" {% if harbor_config.harbor_username %}value="{{ harbor_config.harbor_username }}"{% endif %}>
        </span>
      </div>
      <div class="row my-1">
        <strong class="col col-md-3">
          Harbor password
          <i class="fa-solid fa-circle-info ms-2 text-primary" data-bs-toggle="tooltip" data-bs-placement="right" data-bs-title="Password of an admin account that creates necessary resources for each app on behalf of Strapper. This admin account can be created within Harbor"></i>
        </strong>
        <span class="col col-md-9">
          <input type="text" name="harbor_password" class="form-control col col-md-9" {% if harbor_config.harbor_password %}value="{{ harbor_config.harbor_password }}"{% endif %}>
        </span>
      </div>
      <div class="row my-1">
        <strong class="col col-md-3">
          Harbor robot name prefix
          <i class="fa-solid fa-circle-info ms-2 text-primary" data-bs-toggle="tooltip" data-bs-placement="right" data-bs-title="Prefix for robot account names. Default to '$robot'. Make sure to configure this within Harbor first, then update the prefix here"></i>
        </strong>
        <span class="col col-md-9">
          <input type="text" name="harbor_robot_account_name_prefix" class="form-control col col-md-7" value="{{ harbor_config.harbor_robot_account_name_prefix }}">
          <div class="form-text">Make sure you set this to the same robot name prefix that you set in your Harbor instance. If left empty, default to <strong>"robot$"</strong></div>
        </span>
      </div>

      <!-- Settings to configure container scanning -->
      <h2 class="mt-4">Container scanning</h2>

      <div class="my-4">
        <div class="row">
          <strong class="col col-md-5">Vulnerability severity level threshold</strong>
          <span class="col col-md-7">
            <select name="severity_threshold" class="form-select col col-md-7">
              <option value="Critical" {% if harbor_config.severity_threshold == 'Critical' %}selected{% endif %}>Critical</option>
              <option value="High" {% if harbor_config.severity_threshold == 'High' %}selected{% endif %}>High</option>
              <option value="Medium" {% if harbor_config.severity_threshold == 'Medium' %}selected{% endif %}>Medium</option>
              <option value="Low" {% if harbor_config.severity_threshold == 'Low' %}selected{% endif %}>Low</option>
            </select>
            <div class="form-text">Containers with a vulnerability that's at this level or higher CANNOT be deployed</div>
          </span>
        </div>
      </div>

      <div class="my-4">
        <div class="row">
          <strong class="col col-md-5">Set "Unknown" criticality</strong>
          <span class="col col-md-7">
            <select name="unknown_criticality" class="form-select col col-md-7">
              <option value="Critical" {% if harbor_config.unknown_criticality == 'Critical' %}selected{% endif %}>Critical</option>
              <option value="High" {% if harbor_config.unknown_criticality == 'High' %}selected{% endif %}>High</option>
              <option value="Medium" {% if harbor_config.unknown_criticality == 'Medium' %}selected{% endif %}>Medium</option>
              <option value="Low" {% if harbor_config.unknown_criticality == 'Low' %}selected{% endif %}>Low</option>
            </select>
            <div class="form-text">"Unknown" vulnerabilities will be seen as severe as the level set here</div>
          </span>
        </div>
      </div>

      <div class="my-4">
        <div class="row">
          <strong class="col col-md-5">Rescan interval</strong>
          <span class="col col-md-7">
            <select name="rescan_interval" class="form-select col col-md-7">
              <option value="None" {% if harbor_config.rescan_interval == 'None' %}selected{% endif %}>None</option>
              <option value="Hourly" {% if harbor_config.rescan_interval == 'Hourly' %}selected{% endif %}>Hourly</option>
              <option value="Daily" {% if harbor_config.rescan_interval == 'Daily' %}selected{% endif %}>Daily</option>
              <option value="Weekly" {% if harbor_config.rescan_interval == 'Weekly' %}selected{% endif %}>Weekly</option>
            </select>
            <div class="form-text">Set a period to trigger a scan job for all containers</div>
          </span>
        </div>
      </div>

      <div class="my-4">
        <div class="row">
          <div class="col col-md-5">
            <div>
              <strong>Vulnerabilities notification email template</strong>
            </div>
            <div class="form-text">
              You can write Django or Jinja2 template using the given variables. Here are the avaiable variables:
              <ul>
                <li><strong>name</strong>: Developer account's first name or email if first name doesn't exist</li>
                <li><strong>app_name</strong>: Application's name that contains the vulnerable image</li>
                <li><strong>vuln_images</strong>: Dictionary of severly vulnerable images. The dictionary has the following format:</li>
                                      <pre>

vuln_images = {
'image_name_1:tag_1': {
'severity_level': 'severity_vul_num',
...
},
...
}
                                      </pre>
                <p>Where <strong>severity_level</strong> is from "{{ harbor_config.severity_threshold }}" to above. You might want to use a for loop to iterate through the <strong>vuln_images</strong> object. Here is an example of the <strong>vuln_images</strong> object:</p>
                                      <pre>

vuln_images = {
'myrepo/strapper_web:3.2.1': {
'High': 2,
'Critical': 1,
},
'myrepo/strapper_server:2.0.0': {
'High': 1,
'Critical': 0,
},
}
                                      </pre>
                <li><strong>email_sender</strong>: Sender email that you set in your environment variable (EMAIL_SENDER)</li>
              </ul>
            </div>
          </div>
          <span class="col col-md-7">
            <textarea rows="20" name="vuln_notification_email_template" class="form-control col col-md-7">
              {% if harbor_config.vuln_notification_email_template %}{{ harbor_config.vuln_notification_email_template }}{% endif %}
            </textarea>
            <div class="form-text">Email template used to notify app developers when severe vulnerabilities are detected in one of their containers.</div>
          </span>
        </div>
      </div>

      <button type="button" class="btn btn-danger btn-sm mt-2 cancel-btn">Cancel</button>
      <button type="submit" class="btn btn-dark btn-sm mt-2">Submit</button>
    </form>
  </div>
</div>
